/* Modul		:		
 */

#include "os/system.h"
#include "timer/timer.h"
#include "uart/uart.h"
#include "os/reg_mem.h"

/*************************************************************************
 * Function:	init()
 * Purpose:		system initialize
 * Input:		none
 * Returns:		none
 */
void init(void)
{
    sys_clk_init();
	
    uart_init(UART_BAUD_SELECT(115200, F_CPU));
	
    sei();
}

/*************************************************************************
 * Function:	main()
 * Purpose:		entry point
 * Input:		none
 * Returns:		none
 */
int main(void)
{
    init();
	
	char num[7];
	
	DDRA = 0xff;
	DDRD = 0xff;
	
	uint32_t tick = get_uptime(TICKS) + 100;
	
    while(1)
    {
		if(tick <= get_uptime(TICKS))
		{
			tick = get_uptime(TICKS) + 100;
			PORTA ^= (1<<PINA0);
			PORTD ^= (1<<PIND5);
			
			ultoa( (tick), num, 10);
			uart_puts(num);
			uart_putc(10);
			uart_putc(13);
		}
    }
    
	return 0;
}
