/* Modul		:	
 */

#include "reg_mem.h"

/*******************************************************************************
 * Globale Variablen
 */
static uint16_t reg[NUMBER_OF_REG];

/*******************************************************************************
 * Initialisiert die System-Register
 */
void reg_init(void)
{

}

/*******************************************************************************
 * Liefert ein Registerwert
 */
uint16_t reg_read(uint16_t adr)
{
	return reg[adr];
}

/*******************************************************************************
 * Schreibt ein Registerwert
 */
void reg_write(uint16_t adr, uint16_t value)
{
	reg[adr] = value;
}

/*******************************************************************************
 * Liefert ein 32-Bit Wert ab angegebener Register-Adr.
 */
uint32_t reg_read32(uint16_t adr)
{
	uint32_t value = 0;

	value = reg[adr+1];
	value <<= 16;
	value += reg[adr];

	return value;
}

/*******************************************************************************
 * Schreibt ein 32-Bit Wert ab angegebener Register-Adr.
 */
void reg_write32(uint16_t adr, uint32_t value)
{
	reg[adr] = (uint16_t)value;
	reg[adr+1] = (uint16_t)(value>>16);
}
