/* Modul		:	
 */

#include "../os/system.h"
#include "timer.h"
#include "../os/reg_mem.h"

/*******************************************************************************
 * INTERRUPT - Timer1 (Compare Match)
 */
ISR(TIMER1_COMPA_vect)
{
	reg_write32(SYS_TICKS, reg_read32(SYS_TICKS) + 1);
	reg_write32(UPTIME_SS, reg_read32(SYS_TICKS) / 100);
}

/*******************************************************************************
 * Initialisierung des Timers
 */
void sys_clk_init(void)
{
    /* Compare Match */
	TCCR1A = 0;
	TCCR1B |= (1<<WGM12) | (1<<CS11) | (1<<CS10);
    OCR1A = CLK_PRELOAD_10MS;
    TIMSK1 |= (1<<OCIE1A);
}

/*******************************************************************************
 * Liefert die Laufzeit des Systems seit dem Start
 */
uint32_t get_uptime(uint8_t format)
{
	switch(format)
	{
	case TICKS:
			return reg_read32(SYS_TICKS);
		break;

	case SECOND:
			return reg_read32(UPTIME_SS);
		break;

	case MINUTE:
			return reg_read32(UPTIME_MM);
		break;

	case HOUR:
			return (uint32_t)(reg_read(UPTIME_HH));
		break;

	case DAY:
			return (uint32_t)(reg_read(UPTIME_DD));
		break;
		
	default:
			return 0;
		break;
	}
}
